-- usage:
-- fix variable base too point to your intalled files pass it as a parameter to the program
-- issue command: lua cocodoc.lua > DOC.html
-- or lua cocodoc.lua c;\mycoco > DOC.html
-- DOC.html contains the documetation

--~require('mobdebug').start(host)
local base = ... or  "E:/cocos2d-x/" -- FIX THIS LINE or use parm


local detect = {fileName = 'lua_cocos2dx_3d_manual.cpp'; lineNo = math.huge, debugging=false}
local NL = '</ br>'
base = string.gsub(string.gsub(base,'\\', '/')..'/','/+','/')

local cppFiles = { base .. "cocos/scripting/lua-bindings/auto/"; base .. "cocos/scripting/lua-bindings/manual/"; }
--~local cppFiles = { base .. "cocos/scripting/lua/bindings/"; }
local luaFiles = { base .. "cocos/scripting/lua-bindings/script/" }

if string.match(io.lines(base..'CHANGELOG')(),'3.0') then
    cppFiles = { base .. "cocos/scripting/lua-bindings/auto/";base .. "cocos/scripting/lua-bindings/manual/";}
    luaFiles = { base .. "cocos/scripting/lua-bindings/script/" }
end

if string.match(io.lines(base..'CHANGELOG')(),'3.3') then
    cppFiles = {
        base .. "cocos/scripting/lua-bindings/auto/";
        base .. "cocos/scripting/lua-bindings/manual/";
    }
    luaFiles = {
        base .. "cocos/scripting/lua-bindings/script/",
    }
end

if string.match(io.lines(base..'CHANGELOG')(),'3.4') then
    cppFiles = {
        base .. "cocos/scripting/lua-bindings/auto/";
        base .. "cocos/scripting/lua-bindings/manual/";
    }
    luaFiles = {
        base .. "cocos/scripting/lua-bindings/script/";
    }
end

local nl = '</br>'
local deprecated = false
local cocoBindings, cocoConstants, cocoFunctions = {}, {}, {}
local nCol = 5

local function tstart() print('<table border="3" style="border-color:#4040ff;"><tbody>') end
local function tend() print([[</tbody>]], [[</table>]]) end

local function bold(a) return '<b>'..a..'</b>' end
local function hn(a,n) return '<h'..n..'>'..a..'</h'..n..'>' end
function getFiles(path, ext)
    local tempfile = '\\tempfile.tmp'  -- could be improved
    os.execute('dir /b /s '..string.gsub(path, '/', '\\')..'*.'..ext .. ' > ' .. tempfile)
    local files = {}
    for fn in io.lines(tempfile) do
        table.insert(files, fn)
    end
    os.remove(tempfile)
    return files
end

function cppBinding(fileName)
--~    if string.match(fileName,'deprecated') then return end
    local classesProcs = {}
    local inFile = detect.debugging and string.match(fileName, detect.fileName)
    if detect.debugging and not inFile then return end
    local lineNo, registering, inProc, procTable, arguments = 0
    local holdLuaType, holdName
    local subName
    local lastVectorType = ''
    for line in io.lines(fileName) do
        line = string.gsub(line, '__','_') -- probably an error
        lineNo = lineNo + 1
        if inFile and lineNo  >= detect.lineNo then
            print('['..lineNo..']', line)
        end
        local t, n = string.match(line, 'lua_pushstring.-"(%w+)%.(.-)"')
        if n then holdLuaType, holdName = t, n end
        local className, procName = string.match(line, 'lua_[Cc]ocos2[d]*[x]*_(.+)_(.-)%s*%(%s*lua_State%*%s+[%a_]+%s*%)%s*$')
        registering = registering or string.match(line, 'int lua_register_[Cc]ocos2dx_(.-)%s*%( *lua_State%*%s+[%a_]+%s*%)%s*$') or string.match(line, 'int register_[Cc]ocos2dx_(.-)%s*%( *lua_State%*%s+[%a_]+%s*%)%s*$')
        local luaType, name = string.match(line, 'g_luaType.-"(%w+)%.(.-)"')
        if string.match(line, 'lua_pushcfunction') then
            className, procName = string.match(line, 'lua_[Cc]ocos2[d]*[x]*_(.+)_(.-)%s*%)')
            if procName then luaType, name  = holdLuaType, holdName end
        end
        if procName then
            className = string.match(className, '%w+$')
            classesProcs[className] = classesProcs[className] or {}
            procTable = {where = string.match(fileName,'[_%w%d.]+$')..string.format('(%d)',lineNo)}
            classesProcs[className][procName] = procTable
            arguments, argc = {}, 0
        end
        if procTable and argc then
            local narg = tonumber(string.match(line, 'argc%s*==%s*(%d)') or string.match(line, '(%d)%s*==%s*argc'))
            if narg then
                argc = narg + 1
                arguments = {}
                procTable[argc] = arguments
            end
        end
        if arguments then
            local userType = string.match(line, '!luaval_is_usertype.*"(.*)"')
                or string.match(line, '!tolua_isusertype.*"(.*)"')
                or string.match(line, 'luaval_to_(affinetransform)')
                or string.match(line, 'luaval_to_(boolean)')
                or string.match(line, 'luaval_to_(ccvaluemap)')
                or string.match(line, 'luaval_to_(ccvaluemapintkey)')
                or string.match(line, 'luaval_to_(ccvaluevector)')
                or string.match(line, 'luaval_to_(ccvector)')
                or string.match(line, 'luaval_to_(color3b)')
                or string.match(line, 'luaval_to_(color4b)')
                or string.match(line, 'luaval_to_(color4f)')
                or string.match(line, 'luaval_to_(fontdefinition)')
                or string.match(line, 'luaval_to_(int32)')
                or string.match(line, 'luaval_to_(number)')
                or string.match(line, 'luaval_to_(point)')
                or string.match(line, 'luaval_to_(rect)')
                or string.match(line, 'luaval_to_(size)')
                or string.match(line, 'luaval_to_(ssize)')
                or string.match(line, 'luaval_to_(uint16)')
                or string.match(line, 'luaval_to_(uint32)')
                or string.match(line, 'luaval_to_(vec2)')
                or string.match(line, 'luaval_to_(vec3)')
                or string.match(line, 'luaval_to_(mat4)')
                or string.match(line, 'luaval_to_(ccvalue)')
                or string.match(line, 'luaval_to_(physics_material)')
                or string.match(line, 'luaval_to_(ushort)')
                or string.match(line, 'tolua_tocpp(string)')
                or string.match(line, 'tolua_to(fieldcppstring)')
                or string.match(line, 'tolua_is(boolean)')
                or string.match(line, 'tolua_is(number)')
                or string.match(line, 'tolua_is(string)')
                or string.match(line, 'tolua_is(table)')
                or string.match(line, 'luaval_to_(std_string)')
                or string.match(line, 'luaval_to_(std_vector_int)')
                or string.match(line, 'luaval_to_(std_vector_string)')
                or string.match(line, 'luaval_to_object.*"(.-)"')
            
            if userType then
                local number = tonumber(string.match(line, ', *(%d) *,')) or  (#arguments + 2)
                for _ = #arguments + 3, number do
                    table.insert(arguments, '????')
                end
                table.insert(arguments, lastVectorType or userType)
            end
        end
        local returnType = string.match(line, 'tolua_push(boolean)')
            or string.match(line, 'tolua_push(cppstring)')
            or string.match(line, 'tolua_push(number)')
            or string.match(line, 'tolua_push(string)')
            or string.match(line, '(affinetransform)_to_luaval')
            or string.match(line, '(ccvalue)_to_luaval')
            or string.match(line, '(ccvaluemap)_to_luaval')
            or string.match(line, '(ccvaluemapintkey)_to_luaval')
            or string.match(line, '(ccvaluevector)_to_luaval')
            or string.match(line, '(ccvector)_to_luaval')
            or string.match(line, '(color3b)_to_luaval')
            or string.match(line, '(color4f)_to_luaval')
            or string.match(line, '(fontdefinition)_to_luaval')
            or string.match(line, '(point)_to_luaval')
            or string.match(line, '(rect)_to_luaval')
            or string.match(line, '(size)_to_luaval')
            or string.match(line, '(vec2)_to_luaval')
            or string.match(line, 'object_to_luaval.-"(.-)"')
        if not returnType then
            if string.match(line, 'pushusertype') then
                returnType = string.match(line, '"(.*)"') or 'string'
            end
        end
        if returnType and arguments then
            table.insert(arguments, '='..(lastVectorType or returnType))
        end
        if registering and not subName then
            subName = string.match(line , 'tolua_cclass.tolua_S,".-",".-",(".-")')
            subName = subName and #subName > 2 and string.match(subName, '"(.-)"')
        end
        if luaType then
            if not classesProcs[name] then
                print('No classesProcs[name]', luaType, name, classesProcs[name], lineNo, string.gsub(fileName,'/','\\'), nl)
            else
                cocoBindings[luaType] = cocoBindings[luaType] or {}
                classesProcs[name][1] = subName
                cocoBindings[luaType][name] = cocoBindings[luaType][name] or {}
                for k,v in pairs(classesProcs[name]) do
                    cocoBindings[luaType][name][k] = v
                end
            end
        end
        if string.match(line, '^}%s*$') then
            registering, inProc, subName = nil, nil, nil
        end
        if not string.match(line, '^%s*$') then
            lastVectorType = string.match(line, 'Vector<.->') or string.match(line, 'cocos2d::ValueVector')
            if lastVectorType then
                lastVectorType = string.gsub(string.gsub(lastVectorType, '<', "&#60"), '>', '&#62')
            end
        end
    end
end

function luaBinding(fileName)
    if string.match(fileName, 'Deprecated') and not deprecated then return end
    local lineNo, inBrace, name = 0
    local constants
    for line in io.lines(fileName) do
        lineNo = lineNo + 1
        inBrace = inBrace and not string.match(line, '}')
        if inBrace then
            local k , v = string.match(line,'(%w+).-= *(.*)')
            if v then constants[k] = v end
        end
        for k,v in pairs(cocoBindings) do
            if string.match(line, '^'..k..'%..* = ') then
                cocoConstants[k] = cocoConstants[k] or {}
                inBrace = string.match(line, '{') and not string.match(line, '}')
                inBrace = inBrace or string.match(line,'^'..k..'%.(.*) = *$')
                if inBrace then
                    name = string.match(line,'^'..k..'%.(.*) = ')
                    constants = {}
                    cocoConstants[k][name] = constants
                else
                    cocoConstants[k][string.gsub(line, '^%w+%.','')] = true
                end
            end
            local k, fname, arg = string.match(line,  "^function%s+(%w+)%.(.*)(%(.*)")
            if fname then
                cocoFunctions[k] = cocoFunctions[k] or {}
                cocoFunctions[k][fname] = arg ..':'.. string.match(fileName,'[_%w%d.]+$')..string.format('(%d)',lineNo)
            end
        end
    end
end


for _, dirName in ipairs(cppFiles)  do
    for _,fileName in ipairs(getFiles(dirName, 'cpp')) do
        cppBinding(fileName)
    end
end


function Order(t)
    local ordered = {} -- alphabetic order
    for k in pairs(t)  do if not tonumber(k) then table.insert(ordered, k) end end
    table.sort(ordered)
    return ordered
end

local reference = {}
local function fixReference(a) a=string.gsub(a, '%s+', '') reference[a] = true return a end
local function refFrom(a, b) return ([[<a href="#]]..fixReference(a)..[[">]]..(b or a)..[[</a>]]) end
local function refTo(a) return([[<a id="]]..fixReference(a)..[["></a>]])  end

function printTable(t, border)
    tstart()
    for _,v in ipairs(t) do
        print([[<tr>]])
        for _,v in ipairs(v)  do
            if string.match(v, '<td') then
                print(v)
            else
                local line = [[<td><br />]]
                if tonumber(v) then
                    line = line .. '<div style="text-align: center;">'..tonumber(v)..'</div>'
                else
                    line = line .. v
                end
                print(line..[[</td>]])
            end
        end
        print([[</tr>]])
    end
    tend()
end

print(
[[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<body>]])

print([[<pre>]])

local display = {}

local function toDisplay(a)
    if type(a) == 'table' then
        table.insert(display, a)
    else
        if #display[#display] >= nCol then
            table.insert(display, {a})
        else
            table.insert(display[#display], a)
        end
    end
end

function td(n, backColor)
    return (backColor and '<td bgcolor='.. backColor.. '>'  or '<td>') .. tostring(n) .. '</td>'
end

for _,v in ipairs(Order(cocoBindings))  do
    local orderedClass = Order(cocoBindings[v])
    toDisplay({td(v,'"#00FF00"')})
    toDisplay({})
    for _, v1 in ipairs(orderedClass)  do
        toDisplay(refFrom(v..'.'..v1, v1))
    end
end


print('<h3>NOTE: names preceded by = are returned values.</ br>')
print('NOTE: parameters ???? are probably not checked for type.</h3>')
print('<h3>', refFrom("CONSTANTS"), refFrom("FUNCTIONS", "LUA FUNCTIONS"), refFrom("BASE_CLASS", 'BASE CLASS'), '</h3>')


printTable(display)

for _,v in ipairs(Order(cocoBindings))  do
    local orderedClass = Order(cocoBindings[v])
    print(hn('====== '.. v, 2) .. nl)
    for _,v1 in ipairs(orderedClass)  do
        local base = cocoBindings[v][v1][1] and ' ==> ' .. refFrom(cocoBindings[v][v1][1], cocoBindings[v][v1][1]) or ''
        print(refTo(v..'.'..v1), bold(v..'.'..v1 .. base)) -- object
        local orderedFunction = Order(cocoBindings[v][v1])
        tstart()
        for _, v2 in ipairs(orderedFunction)  do
            print([[<tr>]])
            print(td(v2), td(cocoBindings[v][v1][v2].where))
            cocoBindings[v][v1][v2].where = nil
            if type(cocoBindings[v][v1][v2]) then
                for i3, v3 in pairs(cocoBindings[v][v1][v2])  do
                    print([[<tr>]])
                    local str = td(v2) .. td(i3 - 1)
                    local prev
                    for _, v4 in ipairs(v3)  do
                        if v4 ~= prev or not string.match(v4, '=') then
                            local nm, ref = v4, string.gsub(v4, '=', '')
                            if reference[ref] then
                                nm= refFrom(ref, v4)
                            else
                                nm = v4
                            end
                            str = str .. td(nm, string.match(v4, '^%=') and 'lightgreen')
                            prev = v4
                        end
                    end
                    print(str)
                    print([[</tr>]])
                end
            end
            print([[</tr>]])
        end
        print([[</tr>]])
        tend()
    end
end

for _, dirName in ipairs(luaFiles) do
    for _, fileName in ipairs(getFiles(dirName, 'lua')) do
        luaBinding(fileName)
    end
end

function PrintCoco(aTable, name)
    
    display = {}
    for _,v in ipairs(Order(aTable))  do
        local orderedClass = Order(aTable[v])
        toDisplay({td(v,'"#FFFF00"')})
        toDisplay({})
        for _, v1 in ipairs(orderedClass)  do
            local l, r = string.match(v1, '(.-)=(.*)')
            l = l or v1
            toDisplay(refFrom(v..'.'..l, l))
        end
    end
    
    print(refTo(name), "<h3>"..name.."</h3>")
    
    printTable(display)
    
    for _,v in ipairs(Order(aTable))  do
        local orderedClass = Order(aTable[v])
        print(hn('====== '.. v, 2) .. nl)
        tstart()
        for _, v1 in ipairs(orderedClass)  do
            print([[<tr>]])
            if type(aTable[v][v1]) == 'table' then
                print(td(v1))
--~refTo(v..'.'..v1), v..'.'..v1,) 
                
                for _,v2 in ipairs(Order(aTable[v][v1])) do
                    print([[<tr>]])
                    print(td(' '), td(v2), td(aTable[v][v1][v2]))
                    print([[</tr>]])
                end
            else
                local l, r = string.match(v1, '(.-)=(.*)')
                if r then
                    print(td(refTo(v..'.'..l)..l), td(r))
                else
                    local a, b = string.match(aTable[v][v1], '(.-):(.*)')
                    print(td(refTo(v..'.'..v1)..v1), td(a), td(b))
                end
            end
            print([[</tr>]])
        end
        tend()
    end
end


local function PrintBaseClass()
    print(refTo('BASE_CLASS'), "<h2>".."BASE CLASS (Maybe unresolved)".."</h2>")
    for _,v in ipairs(Order(cocoBindings))  do
        local orderedClass = Order(cocoBindings[v])
        print(hn(v, 2))
        tstart()
        for _,v1 in ipairs(orderedClass)  do
            local base = cocoBindings[v][v1][1] and ' ==> ' .. refFrom(cocoBindings[v][v1][1], cocoBindings[v][v1][1]) or ''
            if base== '' then
                print([[<tr>]])
                print(td(v1, '#FFeCeC'), td(refFrom(v..'.'..v1)))
                print([[</tr>]])
            end
        end
        tend()
    end
end

PrintCoco(cocoConstants, "CONSTANTS")
PrintCoco(cocoFunctions, "FUNCTIONS")
PrintBaseClass()


print([[</pre>]])
print([[</body></html>]])


    